import DAuthFlow from "./dauth/DAuthFlow";
import superagent from "superagent";

class Tide {
  constructor(vendorId, serverUrl, orkNodes) {
    this.vendorId = vendorId;
    this.serverUrl = serverUrl;
    this.orkNodes = orkNodes || [];
  }

  countNodes() {
    return this.orkNodes.length;
  }

  register(username, password) {
    return new Promise(async (resolve, reject) => {
      // Some local validation, which is all we can really do.
      if (username.length < 3 || password.length < 6)
        return reject("Invalid credentials");

      var initUserResult = await superagent.post(
        `${this.serverUrl}/CreateUser/${username}`
      );

      var msaFlow = new DAuthFlow(this.orkNodes, username);
      var cvkFlow = new DAuthFlow(this.orkNodes, username + this.vendorId);
      var c = await msaFlow.signUp(password, 2);
      var key = await msaFlow.signUp(password, 2);
      // var key = await msaFlow.signUp(password, 2);
      // Attempt to fetch an MSA using the given username
      // If a user exists, check to see if we can login. If not, reject
      // If a user does not exist, create a new msa using the given credentials

      // Now that we have an msa, create a new cvk for this user/vendor
      // Return the keys

      resolve({ pub: key.toString(), priv: key.toString() });
    });
  }

  login(username, password) {
    return new Promise(async function (resolve, reject) {
      resolve(true);
    });
  }

  forgotPassword(username) {
    // Trigger selected orks to send email fragments
  }

  combineForgetPasswordFragments(fragments) {}

  resetPassword(username, password) {}
}

export default Tide;
